
--11-8-2017
--http://thegeekforge.com/2017/11/10/arduino-lua-fsuipc-tutorial-001_a/
--
--Tutorial_001_a.

--
--This .lua file is script to teach the very basics of interfacing 
--Arduino built hardware with FSX/P3D using LUA thru the Registered version of FSUIPC.  
--The Arduino companion file for this tutorial is LUA_Arduino_Tutorial_001_a.ino.
--My goal is to write this for the novice to learn. Some of it is rudimentary.
--
--Lesson 001_a Communication from Arduino to LUA:
--This script only does one thing. It receives data from Arduino 
--in order to change the COM1 radio Standby freqency up or down. 
--That's it. 
--Learning to crawl.
--
-- You Will Need:
-- The appropriate registered version for your sim of Pete Dowson's FSUIPC
-- http://www.schiratti.com/dowson.html
--
-- Instructions To Launch the script:
-- * Place this file in the Modules folder of your sim with the other FSUIPC files
-- * Have the COM port of the Arduino handy you will need to enter it on first launch
-- * In P3D go to Add-ons
-- * Select FSUIPC
-- * Select Buttons and Switches Tab
-- * Press a button on your joystick to assign a launch button
-- * Tick the "Select for FS control" box
-- * In the drop down "Control sent when button is pressed"
-- * Scroll down and select "Lua Tutorial 001 A"
-- * NOTE: NOT LuaClear, LuaSet, LuaDebug
-- * You can set another button for "LuaKill Tutorial 001 A"
-- * Hit OK. 
-- * Back in the sim, press the Joystick button that you asigned
-- * Enter the COM port when requested. 
-- * Afterward it should remember the COM port on future launches
-- * Press the buttons on the Arduino and Com 1 radio Standby Mhz should go up and down.

------------------------------------------------------------------
---- Variables ---------------------------------------------------
------------------------------------------------------------------
port_file = "Transponder_and_ADF_PORT.txt"
speed = 115200
handshake = 0
----End of Variables section -------------------------------------

------------------------------------------------------------------
---- Com Port set up and recording.  AKA the Magic section -------
------------------------------------------------------------------
-- Not going to go into this section other than to tell you it will 
-- prompt you for the arduino com port and record it in a text file 
-- that it places in the Modules folder.
file = io.open(port_file, "r")
if file == nil then
	port_number = "10"
	file = io.open(port_file, "w")
	io.output(file)
	io.write(port_number)
	io.close(file)
	Arduino_Com_Port = com.open("COM"..port_number, speed, handshake)
else
	port_number = file:read (2)
	--ipc.display(port_number)
	io.close(file)
	Arduino_Com_Port = com.open("COM"..port_number, speed, handshake)
	ipc.sleep(3000)
end 
if Arduino_Com_Port ~= 0 then
	ipc.display("Arduino Com Port "..port_number.." Open",5)
	
else
	ipc.display("Could not open ARDUINO Com Port")
	ipc.sleep(2000)
	port_number = ipc.ask('\n'..'\n'..'\n'..'\n'..'\n'..'\n'..'\n'..'\n'.." Enter the Arduino Com Port for Your RADIO")
	file = io.open(port_file, "w")
	io.output(file)
	io.write(port_number)
	io.close(file)

	Arduino_Com_Port = com.open("COM"..port_number, speed, handshake)
	ipc.sleep(3000)
	if Arduino_Com_Port == 0 then
		ipc.display("Could not open ARDUINO Com Port",5)
		
		ipc.exit()
	else
		ipc.display("Arduino Com Port "..port_number.." Open",5)
		--ipc.sleep(3000)
		
	end
end 
---- End of Magic section ----------------------------------------


------------------------------------------------------------------
---- Functions ---------------------------------------------------
------------------------------------------------------------------
-- Only one function in this script.  
-- When data comes in from the Arduino, it gets sent to this 
-- function.  When it finds one of the strings in "" it does that
-- ipc.control.



Press_ALT_PREV = 0 


function Arduino_Data(Arduino_Com_Port, datastring, length)





-------------------- Transponder Buttons --------------------


--final
		--- Receives Data from Ardunio for Squawk Cod and VFR Code

		if (string.find(datastring, "TR")) then
			
		Receiveddata = datastring:sub(3,6)	
		
		local Code = tonumber(Receiveddata)
		if  Code == nil then
		Code = 0
		end
	
		local xpdrcode=("0x"..string.format("%04d",Code))
		
	
		local TransCode = ipc.writeUW(0x0354,xpdrcode)
		end


		--- Receives Data from Ardunio for Transponder Knob
		
		if (string.find(datastring, "Off")) then  --XPNDR Off
		ipc.writeLvar("L:xpdr_onoff_knob_pos",0)
		end 	
	
		
		if (string.find(datastring, "STBY")) then  --XPNDR STBY
		ipc.writeLvar("L:xpdr_onoff_knob_pos",1) 
		end

		if (string.find(datastring, "Test")) then  --XPNDR Test
		ipc.writeLvar("L:xpdr_onoff_knob_pos",2) 
		end

		if (string.find(datastring, "On")) then  --XPNDR On
		ipc.writeLvar("L:xpdr_onoff_knob_pos",3) 
		end

		if (string.find(datastring, "ALT")) then  --XPNDR Alt
		ipc.writeLvar("L:xpdr_onoff_knob_pos",4) 
		end


file = io.open("Transponder_Received_From_Arduino.txt","a")
file:write(datastring)
file:close()



end  -- function end


----------------------


function timer1function(CurrentTime) 

-- This Timer function is used to slow down data writes of offsets 
-- that continually read and interfere with Arduino Serial. (Reads every 10 Secs)

Press_ALT = ipc.readDBL(0x34B0) 					--Pressure Altitude at 29.92 in metres.
Press_ALT = string.format("%3d",(Press_ALT*3.28084/100))

if  math.abs(Press_ALT - Press_ALT_PREV) >= 1 then

ipc.writeDBL(0x9510,string.format("%03d",Press_ALT)) 	--converts to feet every 4 secs
end

Press_ALT_PREV = Press_ALT

end

----------------------

function A2A_Battery (offset,value)

ipc.writeUD(0x281C,value)

end 


------------------------

	
function call_radio (offset, value)

	if offset ==0x0354 then 								-- Transponder Code
        command = "=T" .. string.format("%04x", value) .. "\n"
	elseif offset ==0x9510 then 							-- Pressure Altitude for Flight Level from offset 0x34B0
	command = "=F" .. string.format("%03d",value) .. "\n"
   	elseif offset ==0x281C then  							-- Battery
        command = "=B" .. string.format("%02d", value) .. "\n"  
    	elseif offset ==0x2E80 then  							-- Avionics
        command = "=A" .. string.format("%02d", value) .. "\n"
	end 

    ipc.log ("writes com =".. command)  
    com.write (Arduino_Com_Port, command) --Wrties to the Arduino through COM
  

file = io.open("Transponder_Sent_to_Arduino.txt","a")
file:write(command)
file:close()



end



-----------------------------------------------------
---- Events -----------------------------------------
-----------------------------------------------------
-- Events are awesome. They dont require a continuous loop to work.
-- They just sit back and wait for a trigger and then spring into action.
-- Events must go at the bottom of the script. Why? Google it.


event.com(Arduino_Com_Port, 50,1, "Arduino_Data") -- Read Data from Arduino
event.timer(4000, "timer1function")
event.offset (0x0354, "UW", "call_radio") -- Transponder code
event.offset (0x9510, "DBL", "call_radio") -- Transponder Alt
event.offset (0x281C, "UD", "call_radio") -- Battery on/off
event.offset (0x2E80, "UD", "call_radio") -- Avionics on/off
event.Lvar("L:Battery1Switch",100, "A2A_Battery") -- Read Battery on/off A2A


	-- This is event.com, it listens for data on the Arduinos Com port.
	-- The 50 and 1 are the max and min characters accepted
	-- The data is then passed to the "Arduino_Data" function above.

	-- Timer Function can only be used once per Lua. Separate Lua for each one needed.	
	--timer1.lua goes like this:

	--function timer1function(CurrentTime)
	--  ipc.display("Timer1="..CurrentTime)
	--end

	--event.timer(1000, "timer1function")

	--timer2.lua goes like this:

	--function secondtimer(CurrentTime)
   -- ipc.display("Timer2="..CurrentTime)
	--end

	--event.timer(100, "secondtimer")
	